<template>
  <table v-if="numberRows && numberCells">
    <tr
      v-for="currentRowRange in numberRows + 1"
      :key="'r' + currentRowRange"
    >
      <td
        v-for="currentCellRange in numberCells + 1"
        :key="'r' + currentRowRange + 'c' + currentCellRange"
        :class="isCellSelected(currentRowRange, currentCellRange) ? 'selected' : ''"
        @click="toggleCell(currentRowRange, currentCellRange)"
      >
      </td>
    </tr>
  </table>
</template>

<script>
export default {
  name: 'PicrossEditor',
  props: {
    numberRows: {
      type: Number,
      default: 5
    },
    numberCells: {
      type: Number,
      default: 5
    }
  },
  data () {
    return {
      cellsValues: []
    }
  },
  computed: {
    currentPicrossData () {
      // parcours du tableau
      // création d'un objet mémoire recensant les cellules activées
      // on stocke à la fois par colonnes et par lignes
      const rowsData = []
      const columnsCellsData = []
      /**
       * Première étape,
       * on recense chaque cellule
       * dans deux tableaux distincts,
       * * l'un pour les lignes,
       * * l'autre pour les colonnes
       */
      this.cellsValues.forEach(currentRowCells => {
        const rowData = []
        let previousNumberCellsEnabled = 0
        currentRowCells.forEach((currentCellStatus, indexTableColumn) => {
          if (currentCellStatus === true) {
            previousNumberCellsEnabled++
          } else if (previousNumberCellsEnabled > 0) {
            rowData.push(previousNumberCellsEnabled)
            previousNumberCellsEnabled = 0
          }
          if (columnsCellsData.length === indexTableColumn) {
            columnsCellsData.push([])
          }
          columnsCellsData[indexTableColumn].push(currentCellStatus)
        })
        if (previousNumberCellsEnabled > 0) {
          rowData.push(previousNumberCellsEnabled)
        }
        rowsData.push(rowData)
      })

      /**
       * Deuxième étape,
       * on calcule les enchaînements des colonnes
       */
      const columnsData = columnsCellsData.map(currentColumnCellData => {
        const columnData = []
        let previousNumberCellsEnabled = 0
        currentColumnCellData.forEach(currentCell => {
          if (currentCell) {
            previousNumberCellsEnabled++
          } else if (previousNumberCellsEnabled > 0) {
            columnData.push(previousNumberCellsEnabled)
            previousNumberCellsEnabled = 0
          }
        })
        if (previousNumberCellsEnabled > 0) {
          columnData.push(previousNumberCellsEnabled)
        }
        return columnData
      })

      return {
        data: {
          rows: rowsData,
          columns: columnsData
        },
        size: {
          rows: rowsData.length,
          columns: columnsData.length
        }
      }
    }
  },
  methods: {
    makeCellsValuesArray (numberRows, numberCells) {
      const cellsValues = []
      for (let i = 0; i < numberRows; i++) {
        const currentRowCellsValues = new Array(numberCells).fill(false, 0, numberCells)
        cellsValues.push(currentRowCellsValues)
      }
      this.cellsValues = cellsValues
    },
    createCellsValuesArray () {
      this.makeCellsValuesArray(this.numberRows, this.numberCells)
    },
    isCellSelected (rowRange, cellRange) {
      return this.cellsValues?.[rowRange - 2]?.[cellRange - 2]
    },
    toggleCell (rowRange, cellRange) {
      /**
       * ranges are from 1 and not 0 based
       * and we are creating a first row and first column for tips
       * so we exclude the first row, and first column,
       * so we only want range > 1, and they will match the 0 based cellsValues array
       * a row with the range n° 2 is in fact the row with index 0
       * same for cell, cell Range n° 2 is in fact the first cell
       */
      if (rowRange > 1 && cellRange > 1) {
        this.$set(
          this.cellsValues[rowRange - 2],
          cellRange - 2,
          !this.isCellSelected(rowRange, cellRange)
        )
      }
    }
  },
  watch: {
    numberRows: {
      handler: 'createCellsValuesArray',
      immediate: true
    },
    numberCells: {
      handler: 'createCellsValuesArray',
      immediate: true
    },
    cellsValues () {
      this.$emit('update-picross-data', this.currentPicrossData)
    }
  }
}
</script>

<style scoped>
table {
  border: 1px solid gray;
  border-collapse: collapse;
  font-family: monospace;
  text-align: right;
}
tr:nth-child(1) td {
  word-wrap: anywhere;
  white-space: pre-wrap;
  text-align: center;
  vertical-align: bottom;
  max-width: 20px;
}
tr, td {
  height: 20px;
}
td {
  min-width: 20px;
  width: 20px;
  border: 1px solid gray;
}
tr td:nth-child(1) {
  white-space: nowrap;
  width: auto;
  text-align: left;
}
td:hover {
  background-color: red;
}
td:nth-child(5n + 1) {
  border-right: 2px solid black;
}
tr:nth-child(5n + 1) {
  border-bottom: 2px solid black;
}
.selected {
  background-color: blue;
}
</style>
